#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>


char *ltrim(char *s) 
{     
    while(isspace(*s)) s++;     
    return s; 
}  

char *rtrim(char *s) 
{     
    char* back;
    int len = strlen(s);

    if(len == 0)
        return(s); 

    back = s + len;     
    while(isspace(*--back));     
    *(back+1) = '\0';     
    return s; 
}  

char *trim(char *s) 
{     
    return rtrim(ltrim(s));  
} 


int main(int argc, char *argv[]){

    char s[999999];
	if (strcmp(argv[1], "-l") ==0){


    FILE *file = fopen(argv[2], "r");

    if (file == NULL)
    {
        fputs("Failed to open the file\n", stderr);
        return -1;
    }

    int i = 0;
    char ch;
    while ((ch = fgetc(file)) != EOF)
    {
    	if(ch=='\n')
    		ch=' ';
        s[i++] = ch;
    }
    s[i] = '\0'; 

    fclose(file);
    char* original = strdup(s);
    
    char delims[] = ".!?";
    char *token = strtok(s, delims);
    int numPhrases=0;
    while( token != NULL){
        int pos = strlen(token)+token-s;
        token = trim(token);
        printf("[%d] %s%c\n", numPhrases+1, token, original[pos]);
        token = strtok(NULL, delims);
        numPhrases++;
    }

    }
    else if (argc==2){

         FILE *file = fopen(argv[1], "r");

        if (file == NULL)
        {
            fputs("Failed to open the file\n", stderr);
            return -1;
        }

        int i = 0;
        char ch;
        while ((ch = fgetc(file)) != EOF)
        {
            s[i++] = ch;
        }
        s[i] = '\0'; 

        fclose(file);
        
        char delims[] = ".!?";
        int numPhrases=0;

        char *token = strtok(s, delims);
        while( token != NULL){
            token = strtok(NULL, delims);
            numPhrases++;
        }

        printf("%d\n", numPhrases);

    }   
    else{
        printf("usage: phrases [-l] file");
    } 
	
}
